/* Prototypes for functions in hame.library */

void HAME_WritePixel(struct HamePort *h, long x, long y);

long HAME_ReadPixel(struct HamePort * h, long x, long y);

void HAME_WriteLPixel(struct HamePort *h, struct Window *w, long x, long y);

long HAME_ReadLPixel(struct HamePort *h, struct Window *w, long x, long y);

void HAME_WriteWPixel(struct HamePort *h, struct Window *w, long x, long y);

long HAME_ReadWPixel(struct HamePort *h, struct Window *w, long x, long y);

void HAME_SetRGB8(struct HamePort * h, long reg, long rr, long gg, long bb);

void HAME_GetRGB8(struct HamePort * h, long reg);

void HAME_GetRGBPixel(struct HamePort * h, long x, long y);

struct HamePort *HAME_Init(struct Screen * s, long Width, long Height, long Vertices, long type, long start, long cookies, long rows);

void HAME_Dispose(struct HamePort * h);

void HAME_Ellipse(struct HamePort * h, long x, long y, long xr, long yr, long filled);

void HAME_Line(struct HamePort * h, long x1, long y1, long x2, long y2);

void HAME_Box(struct HamePort * h, long x1, long y1, long x2, long y2, long filled);

struct HamePort *HAME_OpenScreen(long lace, long ham, long Width, long Height);

void HAME_CloseScreen(struct HamePort * h);

void HAME_Scroll(struct HamePort * h, long dx, long dy, long x1, long y1, long x2, long y2 );

void HAME_SetAPen( struct HamePort *h, long color);

void HAME_SetBPen( struct HamePort *h, long color);

void HAME_Move( struct HamePort *h, long x, long y);

void HAME_Draw( struct HamePort *h, long x, long y);

void HAME_8BitRender( struct HamePort *h, UBYTE *Source, long x, long y, long width, long height);

struct Clip *HAME_AllocClip( long width, long height, long maskflag );

void HAME_DisposeClip( struct Clip *c );

struct Clip *HAME_GetClip( struct HamePort *h, long x, long y, long width, long height );

void HAME_PutClip( struct HamePort *h, struct Clip *c, long x, long y );

long HAME_ReadClipPixel( struct Clip *c, long x, long y );

void HAME_WriteClipPixel( struct Clip *c, long x, long y, long reg );

long HAME_ReadMaskPixel( struct Clip *c, long x, long y );

void HAME_WriteMaskPixel( struct Clip *c, long x, long y );

void HAME_DisposeClipMask( struct Clip *c );

void HAME_AllocClipMask( struct Clip *c );

void HAME_MakeClipMask( struct Clip *c, long reg );

struct HameFont *   HAME_OpenFont( char *fontname, int points);

void   HAME_SetFontPen( struct HameFont *Font, long color);

void   HAME_MakeFTables( struct HameFont *Font, long color);

long   HAME_GetFontPallete( struct HamePort *h, struct HameFont *Font);

long   HAME_Text( struct HamePort * h, struct HameFont *Font, char * text, int tx, int ty);

long   HAME_QText( struct HamePort * h, struct HameFont *Font, char * text, int tx, int ty);

void   HAME_CloseFont( struct HameFont * h);

void   HAME_WaitScanline( struct HamePort * h, long line);

void   HAME_CheckCookie( struct BitMap *bm, UBYTE *dest, long line, long *loffs);

void   HAME_LockLayer( struct HamePort *hp );

void   HAME_UnlockLayer( struct HamePort *hp );

