/* Prototypes for NCSA HDF version 3.10r3 */
/* Necessary for Amiga SAS/C v5.10a compiler to properly convert
   function calls to there proper type. Prototypes are a good idea
   anyway!
*/
/* Richard Gerber 1/21/91 */

#include <hdf/dfrig.h>
#include <hdf/dfsd.h>
/* File df.c */
DFImemcopy( char *, char *, register int );
DF *DFopen( char *, int, int );
int DFclose( DF * );
int DFIseedDDs( DF * );
int DFIcheck( DF * );
int DFdescriptors( DF *, DFdesc *, int, int );
int DFnumber( DF *, uint16 );
int DFsetfind( DF *, uint16, uint16 );
int DFfind( DF *, DFdesc * );
int DFIfind( DF *, uint16, uint16, int, uint16, uint16, DFdle **, int *);
DFdd *DFIemptyDD( DF * );
int DFaccess( DF *, uint16, uint16, char *);
int DFstart( DF *, uint16, uint16, char *);
int32 DFread( DF *, char *, int32 );
int32 DFseek( DF *, int32 );
int32 DFwrite( DF *, char *, int32 );
int DFupdate( DF * );
int DFstat( DF *, struct DFdata *);
int32 DFgetelement( DF *, uint16, uint16, char *);
int DFputelement( DF *, uint16, uint16, char *, int32 );
int DFdup( DF *, uint16, uint16, uint16, uint16 );
int DFdel( DF *, uint16, uint16 );
uint16 DFnewref( DF * );
DFishdf( char * );
int DFerrno(void);
int DFIerr( DF * );

/* File dfan.c */
int32 DFANgetlablen( char *, uint16, uint16 );
int DFANgetlabel(char *, uint16, uint16, char *, int32 );
int32 DFANgetdesclen(char *, uint16, uint16 );
int DFANgetdesc(char *, uint16, uint16, char *, int32 );
int DFANgetfidlen( DF *, int );
int DFANgetfid( DF *, char *, int, int );
int DFANgetfdslen( DF *, int );
int DFANgetfds( DF *, char *, int, int );
int DFANputlabel( char *, uint16, uint16, char * );
int DFANputdesc( char *, uint16, uint16, char *, int32 );
int DFANaddfid( DF *, char * );
int DFANaddfds( DF *, char *, int32 );
int DFANlastref(void);
int DFANlablist( char *, uint16, uint16 *, char *, int, int, int );
DF *DFANIopen( char *, int );
int DFANIlocate( DF *, int, uint16, uint16 );
int DFANIaddentry(int, uint16, uint16, uint16 );
int32 DFANIgetannlen(char *, uint16, uint16, int );
int DFANIgetann( char *, uint16, uint16, char *, int32, int );
int DFANIputann( char *, uint16, uint16, char *, int32, int );
int DFANIlablist( char *, uint16, uint16 *, char *, int, int, int, int );
int DFANIaddfann( DF *, char *, int32, int );
int DFANIgetfannlen( DF *, int, int );
int DFANIgetfann( DF *, char *, int, int, int );

/* File dfcomp.c */
int DFputcomp( DF *, uint16, uint16, char *, int32, int32, char *,
               char *, int16 );
int DFgetcomp( DF *, uint16, uint16, char *, int32, int32, uint16 );
int DFCrle( char *, char *, int32 );
int DFCunrle( char *, char *, int32, int );

/* File dfgroup.c */
int DFdiread( DF *, uint16, uint16 );
int DFdiget( DFdi * );
int DFdisetup( int );
int DFdiput( uint16, uint16 );
int DFdiwrite( DF *, uint16, uint16 );
int DFDIgetgroup( char *, DFdi *, int, DFdi *);
int DFDIputgroup( char *, DFdi *, int, DFdi *);
 
/* File dfimcomp.c */

void DFCimcomp( int32, int32, char *, char *, char *, char *, int );
static void compress( unsigned char *, int );
static void init_global( int32, int32, char *, char *);
static int cnt_color( int );
static void set_palette( int );
static void fillin_color( int );
static int indx( unsigned char, unsigned char, unsigned char );
static void map( int );
static int nearest_color( unsigned char, unsigned char, unsigned char );
static long int sqr( unsigned char );
void DFCunimcomp( int32, int32, char *, char *);
static void sel_palette( int, int, struct rgb * );
static void init( int, int, struct rgb *);
static void sort( int, int, int, int *);
static int partition( int, int, int, int *);
static struct box *find_box(void);
static void split_box(struct box *);
static void assign_color(void);
static int select_dim(struct box *);
static float find_med( struct box *, int);
static void classify( struct box *, struct box *);
static int next_pt(int, int, int *, int);

/* File dfkit.c */
char *DFIstrncpy(register char *, register char *, int);
int DFconvert(char *, char *, int, register int, register int, int);
char *DFIgetspace(unsigned);
char *DFIfreespace(char *);
/* CSPK32(char *, char *, int *, int *);
SCUP32(char *, char *, int *, int *);
DFIc2fstr( char *, int );
char *DFIf2cstring(_fcd, int );
int DFCVvaxF2ieeeF( union float_uint_uchar *, union float_uint_uchar *);
int DFCVieeeF2vaxF( union float_uint_uchar *, union float_uint_uchar *, int);
*/
/* File dfp.c */
int DFPgetpal( char *, char * );
int DFPputpal( char *, char *, int, char *);
int DFPaddpal( char *, char * );
int DFPnpals( char * );
int DFPreadref( char *, uint16 );
int DFPwriteref( char *, uint16 );
int DFPrestart(void);
int DFPlastref(void);
DF *DFPIopen( char *, int );

/* File dfr8.c */
int DFR8getdims( char *, int32 *, int32 *, int *);
int DFR8getimage( char *, char *, int32, int32, char *);
int DFR8setpalette( char * );
int DFR8Iputimage( char *, char *, int32, int32, int, int );
int DFR8putimage( char *, char *, int32, int32, int);
int DFR8addimage(char *, char *, int32, int32, int);
int DFR8getrig(DF *, uint16, DFRrig *);
int DFR8putrig(DF *, uint16, DFRrig *, int);
int DFR8nimages(char *);
int DFR8readref(char *, uint16);
int DFR8writeref(char *, uint16);
int DFR8restart(void);
int DFR8lastref(void);
DF *DFR8Iopen(char *, int);
int DFR8Iriginfo(DF *);

/* File dfsd.c */
int DFSDgetdims( char *, int *, int32 *, int );
int DFSDgetdatastrs(char *, char *, char *, char *);
int DFSDgetdimstrs(int, char *, char *, char *);
int DFSDgetdatalen(int *, int *, int *, int *);
int DFSDgetdimlen(int, int *, int *, int *);
int DFSDgetdimscale(int, int32, float32 *);
int DFSDgetmaxmin(float32 *, float32 *);
int DFSDgetdata(char *, int, int32 *, float32 *);
int DFSDsetlengths(int, int, int, int);
int DFSDsetdims(int16, int32 *);
int DFSDsetdatastrs(char *, char *, char *, char *);
int DFSDsetdimstrs(int, char *, char *, char *);
int DFSDsetdimscale(int, int32, float32 *);
int DFSDsetmaxmin(float32, float32);
int DFSDputdata(char *, int16, int32 *, float32 *);
int DFSDaddata(char *, int16, int32 *, float32 *);
int DFSDrestart(void);
int DFSDnumber(char *);
int DFSDclear(void);
int DFSDlastref(void);
int DFSDreadref(char *, uint16);
int DFSDgetslice(char *, int32 *, int32 *, float32 *, int32 *);
int DFSDstartslice(char *);
int DFSDputslice(int32 *, float32 *, int32 *);
int DFSDendslice(void);
int DFSDsettype(int, int, int, int);
int DFSDgetsdg(DF *, uint16, DFSsdg *);
int DFSDputsdg(DF *, uint16, DFSsdg *);
DF *DFSDIopen(char *, int);
DFSDIsdginfo(DF *);
int DFSDIclear(DFSsdg *);
int DFSDIgetdata(char *, int, int32 *, float32 *, int);
int DFSDIputdata(char *, int16, int32 *, float32 *, int, int);
int DFSDIgetslice(char *, int32 *, int32 *, float32 *, int32 *, int);
int DFSDIputslice(int32 *, float32 *, int32 *, int);
dsisdas_(char *, char *, char *, char *, int *, int *, int *, int *, int *);
dsisdis_(int *, char *, char *, char *, int *, int *, int *, int *);
/* VSet functions */
int vnewref(DF *);
